// 2022.06.02 Takeshi Yoneki

use winapi::shared::ntdef::NULL;
use winapi::um::winnls::CP_UTF8;
use winapi::um::winnls::CP_ACP;
use winapi::um::stringapiset::MultiByteToWideChar;
use winapi::um::stringapiset::WideCharToMultiByte;

pub fn utf8_to_ansi(u8_string: &str) -> Vec<u8> {
    unsafe {
        let szu8 = u8_string.len() as i32;
        let szw = MultiByteToWideChar(CP_UTF8, 0, u8_string.as_ptr() as *const i8, szu8, NULL as *mut u16, 0);
        let mut wide_string: Vec<u16> = vec![0; szw as usize];
        let _ = MultiByteToWideChar(CP_UTF8, 0, u8_string.as_ptr() as *const i8, szu8, wide_string.as_mut_ptr(), szw);
        let szw = wide_string.len() as i32;
        let sza = WideCharToMultiByte(CP_ACP, 0, wide_string.as_ptr(), szw, NULL as *mut i8, 0, NULL as *const i8, NULL as *mut i32);
        let mut ansi_string: Vec<u8> = vec![0; sza as usize];
        let _ = WideCharToMultiByte(CP_ACP, 0, wide_string.as_ptr(), szw, ansi_string.as_mut_ptr() as *mut i8, sza, NULL as *const i8, NULL as *mut i32);
        ansi_string
    }
}

pub fn ansi_to_utf8(ansi_string: &Vec<u8>) -> String {
    unsafe {
        let sza = ansi_string.len() as i32;
	    let szw = MultiByteToWideChar(CP_ACP, 0, ansi_string.as_ptr() as *const i8, sza, NULL as *mut u16, 0);
        let mut wide_string: Vec<u16> = vec![0; szw as usize];
    	let _ = MultiByteToWideChar(CP_ACP, 0, ansi_string.as_ptr() as *const i8, sza, wide_string.as_mut_ptr(), szw);
        let szw = wide_string.len() as i32;
     	let szu8 = WideCharToMultiByte(CP_UTF8, 0, wide_string.as_ptr(), szw, NULL as *mut i8, 0, NULL as *const i8, NULL as *mut i32);
        let mut utf8_string: Vec<u8> = vec![0; szu8 as usize];
        let _ = WideCharToMultiByte(CP_UTF8, 0, wide_string.as_ptr(), szw, utf8_string.as_mut_ptr() as *mut i8, szu8, NULL as *const i8, NULL as *mut i32);
        String::from_utf8(utf8_string).unwrap()
   }
}
